package evolvekernel.func;

import java.util.*;

public class FastPow
{
	static int size = 100000; 
	static HashMap map = new HashMap(size);

	public static double pow(double val, double power)
	{
		Power p = new Power (val, power); 
		Object o = map.get(p); 
		if (o == null) { 
			double d = Math.pow(val,power); 
			if (map.size() < size) 
				map.put(p, new Double(d)); 
			return d;
		}
		else 
			return ((Double)o).doubleValue();
	}
	
	private static class Power { 
		double val; 
		double power; 
		
		protected Power(double v, double p)
		{
			power = p; 
			val = v; 
		}
	};
}