package evolvekernel.func; 

import ec.*; 
import ec.gp.*; 
import ec.util.*; 
import evolvekernel.*; 
import libsvm.*;

public class DummyTerminal extends GPNode { 
	public String toString() { return "(D)"; } 
	
	public void checkConstraints(final EvolutionState state, final int tree, 
								 final GPIndividual typicalIndividual, 
								 final Parameter individualBase)
	{
		super.checkConstraints(state, tree, typicalIndividual, individualBase); 
		if (children.length!=0) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread,
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual,
					 final Problem problem) 
	{
		KernelData kd = (KernelData)input; 
		/*
		int len = kd.x.length; 
		if ((len%2)==0) { 
			for (int i=0; i < len; i+=2) { 
				kd.x[i].index = 0;  kd.x[i].value = 0;
				kd.x[i+1].index = 0;  kd.x[i+1].value = 0;
			}
		}
		else { 
			for (int i=0; i < len; i++) { 
				kd.x[i].index = 0;
				kd.x[i].value = 0;
			}
		}
		 */
	}
}


